#include <stdio.h>

/* Program broji razmake, linije i tabulatore u ulaznom tekstu */
int main()
{
  int c;
  int br_nl = 0, br_tab = 0, br_bl = 0; /* Brojaci */


  
  while((c = getchar()) != EOF)
    {

      /*
	Implementacija pomocu if-else-if-a:
	if(c == ' ')
	br_bl++;
	else if(c == '\t')
	br_tab++;
	else if(c == '\n')
	br_nl++;
      */
      
      /* Implementacija pomocu switch naredbe */
      switch(c)
	{
	case ' ':   /* Slucaj razmaka - uvecavamo brojac i prekidamo switch */
	  br_bl++;
	  break;
	case '\t':  /* Slucaj tabulatora */
          br_tab++;
	  break;	
	case '\n': /* Slucaj novog reda */
	  br_nl++;
	  break;
	}
    }


  /* NAPOMENA: 
     Naredba switch se koristi za ispitivanje slucajeva. Njena sintaksa je:


     switch(celobrojni_izraz)
     {
       case celobrojna_konstanta1:
         naredbe1
       case celobrojna_konstanta2:
         naredbe2
       ...
       case celobrojna_konstantan:
         naredben
       default:
         podrazumevane_naredbe
     }
     
     pri cemu se default slucaj moze izostaviti. Naredba se izvrsava na 
     sledeci nacin: najpre se izracuna celobrojni_izraz. Zatim se medju
     ponudjenim celobrojnim konstantama trazi prva konstanta koja je 
     jednaka vrednosti izraza, i od tog case-a zapocinje izvrsavanje 
     naredbi koje slede neposredno ispod njega. Izvrsavaju se sve naredbe
     do prve break naredbe, ili do kraja switch bloka, ukoliko ni jedan
     break ne postoji. Uobicajeno je da se svaki case zavrsava break-om,
     ali to ne mora da bude slucaj (ponekad bas zelimo da ne bude tako).
     
     Ukoliko ne postoji ni jedna celobrojna konstanta koja je jednaka 
     vrednosti izraza, tada se izvrsavanje zapocinje od labele default,
     ako ista postoji, a u suprotnom se ne izvrsava nista. 

     Celobrojne konstante se mogu navesti u bilo kom obliku, pa i kao 
     karakterske konstante.     
   */

  printf("Broj linija: %d\nBroj tabulatora: %d\nBroj belina: %d\n", 
	 br_nl, br_tab, br_bl);

  return 0;
}
